<template>
<modal name="authentication" transition="pop-out" :width="modalWidth" :height="400">
  <div class="flex-container">
    <div class="flex-item">
      <div class="title">Authentication</div>
      <form autocomplete="false">
        <input type="text" placeholder="Username" v-model="username">
        <input type="email" placeholder="Email" v-model="email">
        <input type="password" placeholder="Password" v-model="password">
      </form>
      <div class="flex-buttons">
        <button @click="login" class="flex-button">Login</button>
        <button @click="register" class="flex-button">Register</button>
      </div>
      <div class="resetpassword">
        <span>Forgot password?</span>
        <button @click="resetpassword" class="flex-button">Reset Password</button>
      </div>
    </div>
    <div class="flex-item promo-image"></div>
  </div>
</modal>
</template>
<script>
import { HTTP } from '@/common/http'
const MODAL_WIDTH = 656
export default {
  name: 'auth',
  data () {
    return {
      username: '',
      email: '',
      password: '',
      modalWidth: MODAL_WIDTH
    }
  },
  methods: {
    login () {
      var formData = {
        username: this.username,
        password: this.password
      }
      if (formData.username === '' || formData.password === '') {
        this.$snotify.error('Username and Password required to login.')
        return
      }
      this.$bar.start()
      HTTP.post('account/login', formData).then(response => {
        this.$store.commit('setToken', response.data.token)
        this.$store.commit('setUsername', response.data.username)
        this.$snotify.success('You successfully logged in.', 'Success')
        this.$bar.finish()
      }).catch(e => {
        if (e.response.status === 429) {
          this.$snotify.error(e.response.status + ': Too many requests, try again.')
        } else {
          this.$snotify.error(e.response.status + ': ' + e.response.data.message)
        }
        this.$bar.finish()
      })
    },
    register () {
      var formData = {
        username: this.username,
        password: this.password,
        email: this.email
      }
      if (formData.username === '' || formData.password === '') {
        this.$snotify.error('Username and Password required to register.')
        return
      }
      this.$bar.start()
      HTTP.post('account/register', formData).then(response => {
        this.$store.commit('setToken', response.data.token)
        this.$store.commit('setUsername', response.data.username)
        this.$snotify.success('You successfully registered an account.', 'Success')
        this.$bar.finish()
      }).catch(e => {
        if (e.response.status === 429) {
          this.$snotify.error(e.response.status + ': Too many requests, try again.')
        } else {
          this.$snotify.error(e.response.status + ': ' + e.response.data.message)
        }
        this.$bar.finish()
      })
    },
    resetpassword () {
      var formData = {
        username: this.username,
        email: this.email
      }
      if (formData.username === '' || formData.email === '') {
        this.$snotify.error('Username and Email required to register.')
        return
      }
      this.$bar.start()
      HTTP.post('account/register', formData).then(response => {
        this.$snotify.success('Check your email for password reset instructions.', 'Success')
        this.$bar.finish()
      }).catch(e => {
        if (e.response.status === 429) {
          this.$snotify.error(e.response.status + ': Too many requests, try again.')
        } else {
          this.$snotify.error(e.response.status + ': ' + e.response.data.message)
        }
        this.$bar.finish()
      })
    }
  },
  created () {
    this.modalWidth = window.innerWidth < MODAL_WIDTH
      ? MODAL_WIDTH / 2
      : MODAL_WIDTH
  }
}
</script>
<style lang="scss" scoped>
.flex-container {
  display: -webkit-flex;
  display: flex;
  height: 100%;
  .flex-item {
    flex: 1;
    .title {
      text-align: center;
      text-transform: uppercase;
    }
    form {
      width: 90%;
      input {
        width: 100%;
        margin: .2rem 0 .2rem 5%;
      }
    }
    .flex-buttons {
      display: -webkit-flex;
      display: flex;
      .flex-button {
        flex: 1;
        margin: .5rem;
      }
    }
    .resetpassword {
      margin-left: 5%;
    }
  }
  @media only screen and (max-width: 40em) {
    .promo-image {
      display: none;
    }
  }
}
.promo-image {
  background: url("/static/img/panorama.jpg") no-repeat top left;
}
</style>
